package com.bonus.system.controller;

import java.util.ArrayList;
import java.util.List;
import javax.servlet.http.HttpServletResponse;

import com.bonus.common.log.annotation.SysLog;
import com.bonus.common.log.enums.OperaType;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.bonus.common.core.utils.poi.ExcelUtil;
import com.bonus.common.core.web.controller.BaseController;
import com.bonus.common.core.web.domain.AjaxResult;
import com.bonus.common.core.web.page.TableDataInfo;
import com.bonus.common.security.annotation.RequiresPermissions;
import com.bonus.common.security.utils.SecurityUtils;
import com.bonus.system.api.domain.SysDept;
import com.bonus.system.api.domain.SysRole;
import com.bonus.system.api.domain.SysUser;
import com.bonus.system.domain.SysUserRole;
import com.bonus.system.service.ISysDeptService;
import com.bonus.system.service.ISysRoleService;
import com.bonus.system.service.ISysUserService;

/**
 * 角色信息
 * 
 * @author bonus
 */
@RestController
@RequestMapping("/role")
public class SysRoleController extends BaseController
{
    @Autowired
    private ISysRoleService roleService;

    @Autowired
    private ISysUserService userService;

    @Autowired
    private ISysDeptService deptService;

    @RequiresPermissions("system:role:list")
    @GetMapping("/list")
    @SysLog(title = "角色管理", businessType = OperaType.QUERY,logType = 0,module = "系统管理->角色管理",details = "查询角色列表")
    public TableDataInfo list(SysRole role) {
        try{
            startPage();
            List<SysRole> list = roleService.selectRoleList(role);
            return getDataTable(list);
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return  getDataTableError(new ArrayList<>());
    }


    @RequiresPermissions("system:role:export")
    @PostMapping("/export")
    @SysLog(title = "角色管理", businessType = OperaType.EXPORT,logType = 0,module = "系统管理->角色管理",details = "导出角色excel")
    public void export(HttpServletResponse response, SysRole role) {
        try{
            List<SysRole> list = roleService.selectRoleList(role);
            ExcelUtil<SysRole> util = new ExcelUtil<SysRole>(SysRole.class);
            util.exportExcel(response, list, "角色数据");
        }catch (Exception e){
            logger.error(e.toString(),e);
        }

    }

    /**
     * 根据角色编号获取详细信息
     */
    @RequiresPermissions("system:role:query")
    @GetMapping(value = "/{roleId}")
    public AjaxResult getInfo(@PathVariable Long roleId) {
        try{
            roleService.checkRoleDataScope(roleId);
            return success(roleService.selectRoleById(roleId));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");
    }

    /**
     * 新增角色
     */
    @RequiresPermissions("system:role:add")
    @PostMapping
    @SysLog(title = "角色管理", businessType = OperaType.INSERT,logType = 0,module = "系统管理->角色管理",details = "新增角色")
    public AjaxResult add(@Validated @RequestBody SysRole role) {
        try{
            if (!roleService.checkRoleNameUnique(role)) {
                return error("新增角色'" + role.getRoleName() + "'失败，角色名称已存在");
            } else if (!roleService.checkRoleKeyUnique(role)) {
                return error("新增角色'" + role.getRoleName() + "'失败，角色权限已存在");
            }else if (!roleService.checkRoleCodeUnique(role)) {
                return error("新增角色'" + role.getRoleCode() + "'失败，角色编码已存在");
            }
            role.setCreateBy(SecurityUtils.getUsername());
            return toAjax(roleService.insertRole(role));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");
    }

    /**
     * 修改保存角色
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping
    @SysLog(title = "角色管理", businessType = OperaType.UPDATE,logType = 0,module = "系统管理->角色管理",details = "修改角色")
    public AjaxResult edit(@Validated @RequestBody SysRole role) {
        try{
            roleService.checkRoleAllowed(role);
            roleService.checkRoleDataScope(role.getRoleId());
            if (!roleService.checkRoleNameUnique(role)) {
                return error("修改角色'" + role.getRoleName() + "'失败，角色名称已存在");
            } else if (!roleService.checkRoleKeyUnique(role)) {
                return error("修改角色'" + role.getRoleName() + "'失败，角色权限已存在");
            }else if (!roleService.checkRoleCodeUnique(role)) {
                return error("修改角色'" + role.getRoleCode() + "'失败，角色编码已存在");
            }
            role.setUpdateBy(SecurityUtils.getUsername());
            return toAjax(roleService.updateRole(role));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");

    }

    /**
     * 修改保存数据权限
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping("/dataScope")
    @SysLog(title = "角色管理", businessType = OperaType.UPDATE,logType = 0,module = "系统管理->角色管理",details = "修改权限")
    public AjaxResult dataScope(@RequestBody SysRole role) {
        try{
            roleService.checkRoleAllowed(role);
            roleService.checkRoleDataScope(role.getRoleId());
            return toAjax(roleService.authDataScope(role));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");
    }

    /**
     * 状态修改
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping("/changeStatus")
    @SysLog(title = "角色管理", businessType = OperaType.UPDATE,logType = 0,module = "系统管理->角色管理",details = "修改角色状态")
    public AjaxResult changeStatus(@RequestBody SysRole role) {
        try{
            roleService.checkRoleAllowed(role);
            roleService.checkRoleDataScope(role.getRoleId());
            role.setUpdateBy(SecurityUtils.getUsername());
            return toAjax(roleService.updateRoleStatus(role));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");


    }

    /**
     * 删除角色
     */
    @RequiresPermissions("system:role:remove")
    @DeleteMapping("/{roleIds}")
    @SysLog(title = "角色管理", businessType = OperaType.DELETE,logType = 0,module = "系统管理->角色管理",details = "删除角色信息")
    public AjaxResult remove(@PathVariable Long[] roleIds) {
        try{
            return toAjax(roleService.deleteRoleByIds(roleIds));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");


    }

    /**
     * 获取角色选择框列表
     */
    @RequiresPermissions("system:role:query")
    @GetMapping("/optionselect")
    public AjaxResult optionselect() {
        try{
            return success(roleService.selectRoleAll());
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");

    }
    /**
     * 查询已分配用户角色列表
     */
    @RequiresPermissions("system:role:list")
    @GetMapping("/authUser/allocatedList")
    public TableDataInfo allocatedList(SysUser user) {
        try{
            startPage();
            List<SysUser> list = userService.selectAllocatedList(user);
            return getDataTable(list);
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return getDataTableError(new ArrayList<>());

    }

    /**
     * 查询未分配用户角色列表
     */
    @RequiresPermissions("system:role:list")
    @GetMapping("/authUser/unallocatedList")
    @SysLog(title = "角色管理", businessType = OperaType.QUERY,logType = 0,module = "系统管理->角色管理->分配用户",details = "查询预分配用户列表")
    public TableDataInfo unallocatedList(SysUser user) {
        try{
            startPage();
            List<SysUser> list = userService.selectUnallocatedList(user);
            return getDataTable(list);
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return getDataTableError(new ArrayList<>());
    }

    /**
     * 取消授权用户
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping("/authUser/cancel")
    @SysLog(title = "角色管理", businessType = OperaType.UPDATE,logType = 0,module = "系统管理->角色管理->分配用户",details = "取消授权用户")
    public AjaxResult cancelAuthUser(@RequestBody SysUserRole userRole) {
        try{
            return toAjax(roleService.deleteAuthUser(userRole));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");

    }

    /**
     * 批量取消授权用户
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping("/authUser/cancelAll")
    @SysLog(title = "角色管理", businessType = OperaType.GRANT,logType = 0,module = "系统管理->角色管理->分配用户",details = "取消授权用户")
    public AjaxResult cancelAuthUserAll(Long roleId, Long[] userIds) {
        try{
            return toAjax(roleService.deleteAuthUsers(roleId, userIds));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");

    }

    /**
     * 批量选择用户授权
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping("/authUser/selectAll")
    @SysLog(title = "角色管理", businessType = OperaType.GRANT,logType = 0,module = "系统管理->角色管理->分配用户",details = "授权用户")
    public AjaxResult selectAuthUserAll(Long roleId, Long[] userIds) {
        try{
            roleService.checkRoleDataScope(roleId);
            return toAjax(roleService.insertAuthUsers(roleId, userIds));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");
    }

    /**
     * 获取对应角色部门树列表
     */
    @RequiresPermissions("system:role:query")
    @GetMapping(value = "/deptTree/{roleId}")
    public AjaxResult deptTree(@PathVariable("roleId") Long roleId) {
        try{
            AjaxResult ajax = AjaxResult.success();
            ajax.put("checkedKeys", deptService.selectDeptListByRoleId(roleId));
            ajax.put("depts", deptService.selectDeptTreeList(new SysDept()));
            return ajax;
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");
    }
}
